/* Generated by re2c 0.13.5 on Mon Mar  8 18:23:14 2010 */
#line 1 "fastpath.re"
/*
  +----------------------------------------------------------------------+
  | XHP                                                                  |
  +----------------------------------------------------------------------+
  | Copyright (c) 2009 - 2010 Facebook, Inc. (http://www.facebook.com)          |
  +----------------------------------------------------------------------+
  | This source file is subject to version 3.01 of the PHP license,      |
  | that is bundled with this package in the file LICENSE.PHP, and is    |
  | available through the world-wide-web at the following url:           |
  | http://www.php.net/license/3_01.txt                                  |
  | If you did not receive a copy of the PHP license and are unable to   |
  | obtain it through the world-wide-web, please send a note to          |
  | license@php.net so we can mail you a copy immediately.               |
  +----------------------------------------------------------------------+
*/

#include "fastpath.hpp"
#include <stdio.h>

bool xhp_fastpath(const char* yy, const size_t len, const xhp_flags_t &flags) {
  const char* YYMARKER = NULL;
  enum {
    HTML,
    PHP,
    COMMENT_EOL,
    COMMENT_BLOCK
  } state = flags.eval ? PHP : HTML;

  #define YYCURSOR yy
  #define YYCTYPE char
  #define YYGETCONDITION() state
  #define YYFILL(ii)
  #define YYDEBUG(s, c) printf("%03d: %c [%d]\n", s, c, c)

  for (;;) {

#line 40 "fastpath.cpp"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	switch (YYGETCONDITION()) {
	case COMMENT_BLOCK: goto yyc_COMMENT_BLOCK;
	case COMMENT_EOL: goto yyc_COMMENT_EOL;
	case HTML: goto yyc_HTML;
	case PHP: goto yyc_PHP;
	}
/* *********************************** */
yyc_COMMENT_BLOCK:

	YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy6;
	case '*':	goto yy4;
	default:	goto yy2;
	}
yy2:
	++YYCURSOR;
#line 101 "fastpath.re"
	{ continue; }
#line 64 "fastpath.cpp"
yy4:
	++YYCURSOR;
	switch ((yych = *YYCURSOR)) {
	case '/':	goto yy8;
	default:	goto yy5;
	}
yy5:
#line 44 "fastpath.re"
	{ continue; }
#line 74 "fastpath.cpp"
yy6:
	++YYCURSOR;
#line 43 "fastpath.re"
	{ return false; }
#line 79 "fastpath.cpp"
yy8:
	++YYCURSOR;
#line 102 "fastpath.re"
	{
      state = PHP;
      continue;
    }
#line 87 "fastpath.cpp"
/* *********************************** */
yyc_COMMENT_EOL:
	YYFILL(2);
	yych = *YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy18;
	case '\n':	goto yy14;
	case '\r':	goto yy16;
	case '?':	goto yy17;
	default:	goto yy12;
	}
yy12:
	++YYCURSOR;
yy13:
#line 44 "fastpath.re"
	{ continue; }
#line 104 "fastpath.cpp"
yy14:
	++YYCURSOR;
yy15:
#line 92 "fastpath.re"
	{
      state = PHP;
      continue;
    }
#line 113 "fastpath.cpp"
yy16:
	yych = *++YYCURSOR;
	switch (yych) {
	case '\n':	goto yy22;
	default:	goto yy15;
	}
yy17:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy20;
	default:	goto yy13;
	}
yy18:
	++YYCURSOR;
#line 43 "fastpath.re"
	{ return false; }
#line 130 "fastpath.cpp"
yy20:
	++YYCURSOR;
#line 96 "fastpath.re"
	{
      state = HTML;
      continue;
    }
#line 138 "fastpath.cpp"
yy22:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy15;
/* *********************************** */
yyc_HTML:
	YYFILL(7);
	yych = *YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy28;
	case '<':	goto yy27;
	default:	goto yy25;
	}
yy25:
	++YYCURSOR;
yy26:
#line 44 "fastpath.re"
	{ continue; }
#line 157 "fastpath.cpp"
yy27:
	yych = *++YYCURSOR;
	switch (yych) {
	case '%':	goto yy30;
	case '?':	goto yy32;
	default:	goto yy26;
	}
yy28:
	++YYCURSOR;
#line 43 "fastpath.re"
	{ return false; }
#line 169 "fastpath.cpp"
yy30:
	++YYCURSOR;
	switch ((yych = *YYCURSOR)) {
	case '=':	goto yy42;
	default:	goto yy31;
	}
yy31:
#line 56 "fastpath.re"
	{
      if (flags.asp_tags) {
        state = PHP;
      }
      continue;
    }
#line 184 "fastpath.cpp"
yy32:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '=':	goto yy36;
	case 'P':
	case 'p':	goto yy34;
	default:	goto yy33;
	}
yy33:
#line 50 "fastpath.re"
	{
      if (flags.short_tags) {
        state = PHP;
      }
      continue;
    }
#line 202 "fastpath.cpp"
yy34:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'H':
	case 'h':	goto yy37;
	default:	goto yy35;
	}
yy35:
	YYCURSOR = YYMARKER;
	goto yy33;
yy36:
	yych = *++YYCURSOR;
	goto yy33;
yy37:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'P':
	case 'p':	goto yy38;
	default:	goto yy35;
	}
yy38:
	yych = *++YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case ' ':	goto yy39;
	case '\r':	goto yy41;
	default:	goto yy35;
	}
yy39:
	++YYCURSOR;
yy40:
#line 46 "fastpath.re"
	{
      state = PHP;
      continue;
    }
#line 240 "fastpath.cpp"
yy41:
	yych = *++YYCURSOR;
	switch (yych) {
	case '\n':	goto yy39;
	default:	goto yy40;
	}
yy42:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy31;
/* *********************************** */
yyc_PHP:
	YYFILL(8);
	yych = *YYCURSOR;
	switch (yych) {
	case 0x00:	goto yy59;
	case '"':	goto yy47;
	case '#':	goto yy48;
	case '%':	goto yy50;
	case '&':	goto yy51;
	case '\'':	goto yy52;
	case ')':	goto yy53;
	case '/':	goto yy54;
	case ':':	goto yy55;
	case '<':	goto yy56;
	case '?':	goto yy57;
	case 'B':
	case 'b':	goto yy58;
	default:	goto yy45;
	}
yy45:
	++YYCURSOR;
yy46:
#line 44 "fastpath.re"
	{ continue; }
#line 276 "fastpath.cpp"
yy47:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x00) goto yy46;
	goto yy62;
yy48:
	++YYCURSOR;
yy49:
#line 75 "fastpath.re"
	{
      state = COMMENT_EOL;
      continue;
    }
#line 290 "fastpath.cpp"
yy50:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy89;
	default:	goto yy46;
	}
yy51:
	yych = *++YYCURSOR;
	switch (yych) {
	case '#':	goto yy81;
	default:	goto yy46;
	}
yy52:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x00) goto yy46;
	goto yy65;
yy53:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy87;
	case '[':	goto yy81;
	default:	goto yy46;
	}
yy54:
	yych = *++YYCURSOR;
	switch (yych) {
	case '*':	goto yy84;
	case '/':	goto yy86;
	case '>':	goto yy81;
	default:	goto yy46;
	}
yy55:
	yych = *++YYCURSOR;
	switch (yych) {
	case '0':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case 'a':
	case 'b':
	case 'c':
	case 'd':
	case 'e':
	case 'f':
	case 'g':
	case 'h':
	case 'i':
	case 'j':
	case 'k':
	case 'l':
	case 'm':
	case 'n':
	case 'o':
	case 'p':
	case 'q':
	case 'r':
	case 's':
	case 't':
	case 'u':
	case 'v':
	case 'w':
	case 'x':
	case 'y':
	case 'z':	goto yy81;
	case ':':	goto yy82;
	default:	goto yy46;
	}
yy56:
	yych = *++YYCURSOR;
	switch (yych) {
	case '/':	goto yy72;
	default:	goto yy46;
	}
yy57:
	yych = *++YYCURSOR;
	switch (yych) {
	case '>':	goto yy70;
	default:	goto yy46;
	}
yy58:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case '"':	goto yy61;
	case '\'':	goto yy64;
	default:	goto yy46;
	}
yy59:
	++YYCURSOR;
#line 43 "fastpath.re"
	{ return false; }
#line 419 "fastpath.cpp"
yy61:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
yy62:
	switch (yych) {
	case 0x00:	goto yy63;
	case '"':	goto yy67;
	case '\\':	goto yy69;
	default:	goto yy61;
	}
yy63:
	YYCURSOR = YYMARKER;
	switch (yyaccept) {
	case 0: 	goto yy46;
	case 1: 	goto yy73;
	}
yy64:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
yy65:
	switch (yych) {
	case 0x00:	goto yy63;
	case '\'':	goto yy67;
	case '\\':	goto yy66;
	default:	goto yy64;
	}
yy66:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
	goto yy64;
yy67:
	++YYCURSOR;
#line 74 "fastpath.re"
	{ continue; }
#line 457 "fastpath.cpp"
yy69:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
	goto yy61;
yy70:
	++YYCURSOR;
#line 63 "fastpath.re"
	{
      state = HTML;
      continue;
    }
#line 470 "fastpath.cpp"
yy72:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	switch (yych) {
	case 'S':
	case 's':	goto yy74;
	default:	goto yy73;
	}
yy73:
#line 88 "fastpath.re"
	{
      return true;
    }
#line 484 "fastpath.cpp"
yy74:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'C':
	case 'c':	goto yy75;
	default:	goto yy63;
	}
yy75:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'R':
	case 'r':	goto yy76;
	default:	goto yy63;
	}
yy76:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'I':
	case 'i':	goto yy77;
	default:	goto yy63;
	}
yy77:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'P':
	case 'p':	goto yy78;
	default:	goto yy63;
	}
yy78:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'T':
	case 't':	goto yy79;
	default:	goto yy63;
	}
yy79:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy79;
	case '>':	goto yy70;
	default:	goto yy63;
	}
yy81:
	yych = *++YYCURSOR;
	goto yy73;
yy82:
	++YYCURSOR;
#line 83 "fastpath.re"
	{ continue; }
#line 539 "fastpath.cpp"
yy84:
	++YYCURSOR;
#line 79 "fastpath.re"
	{
      state = COMMENT_BLOCK;
      continue;
    }
#line 547 "fastpath.cpp"
yy86:
	yych = *++YYCURSOR;
	goto yy49;
yy87:
	++YYCURSOR;
	YYFILL(1);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case '\n':
	case '\r':
	case ' ':	goto yy87;
	case '[':	goto yy81;
	default:	goto yy63;
	}
yy89:
	++YYCURSOR;
#line 67 "fastpath.re"
	{
      if (flags.asp_tags) {
        state = PHP;
      }
      continue;
    }
#line 572 "fastpath.cpp"
}
#line 106 "fastpath.re"

  }
  return false;
}
